Index: /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/ClientGroupDao.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/ClientGroupDao.cs	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/ClientGroupDao.cs	(revision 3931)
@@ -13,5 +13,5 @@
 
     public ClientGroupDto FindById(Guid id) {
-      return (from cc in Context.ClientGroups
+      return (from cc in Context.Resources.OfType<ClientGroup>()
               where cc.ResourceId.Equals(id)
               select EntityToDto(cc, null)).SingleOrDefault();
@@ -20,5 +20,5 @@
 
     public IEnumerable<ClientGroupDto> FindAll() {
-      return (from cc in Context.ClientGroups
+      return (from cc in Context.Resources.OfType<ClientGroup>()
               select EntityToDto(cc, null)).ToList();
     }
@@ -30,5 +30,5 @@
 
       ClientGroup cc = DtoToEntity(bObj, null);
-      Context.ClientGroups.InsertOnSubmit(cc);
+      Context.Resources.InsertOnSubmit(cc);
       CommitChanges();
       bObj.Id = cc.ResourceId;
@@ -48,5 +48,5 @@
 
     public void Update(ClientGroupDto bObj) {
-      ClientGroup client = Context.ClientGroups.SingleOrDefault(c => c.ResourceId.Equals(bObj.Id));
+      ClientGroup client = Context.Resources.OfType<ClientGroup>().SingleOrDefault(c => c.ResourceId.Equals(bObj.Id));
       DtoToEntity(bObj, client);
       CommitChanges();
@@ -54,7 +54,7 @@
 
     public void AddRessourceToClientGroup(Guid resource, Guid clientGroupId) {
-      ClientGroup cg = Context.ClientGroups.SingleOrDefault(c => c.ResourceId.Equals(clientGroupId));
+      ClientGroup cg = Context.Resources.OfType<ClientGroup>().SingleOrDefault(c => c.ResourceId.Equals(clientGroupId));
       Resource res = Context.Resources.SingleOrDefault(r => r.ResourceId.Equals(resource));
-      cg.ClientGroup_Resources.Add(new ClientGroup_Resource { ClientGroup = cg, Resource = res });      
+      cg.ClientGroup_Resources_Children.Add(new ClientGroup_Resource { ClientGroup = cg, Resource = res });      
       CommitChanges();
     }
@@ -77,5 +77,5 @@
       List<ClientGroupDto> groupList = new List<ClientGroupDto>();
 
-      var q = (from cg in Context.ClientGroups
+      var q = (from cg in Context.Resources.OfType<ClientGroup>()
                where !Context.ClientGroup_Resources.Any(cgr => cgr.ResourceId.Equals(cg.ResourceId))
                select cg);
@@ -84,5 +84,5 @@
         ClientGroupDto cgd = EntityToDto(cg, null);
         groupList.Add(cgd);
-        FillSubGroupsAndClientsRecursivly(cgd, cg.ClientGroup_Resources);        
+        FillSubGroupsAndClientsRecursivly(cgd, cg.ClientGroup_Resources_Children);        
       }
       return groupList;
@@ -93,6 +93,6 @@
       //Get all the Groups
       
-      var qGroups = (from cg in Context.ClientGroups
-               where cg.Resource.ClientGroup_Resources.Any(cgr => cgr.ClientGroupId.Equals(parentClientGroup.Id))
+      var qGroups = (from cg in Context.Resources.OfType<ClientGroup>()
+               where cg.ClientGroup_Resources_Parents.Any(cgr => cgr.ClientGroupId.Equals(parentClientGroup.Id))
                select cg);
 
@@ -100,10 +100,10 @@
         ClientGroupDto cgd = EntityToDto(cg, null);
         parentClientGroup.Resources.Add(cgd);
-        FillSubGroupsAndClientsRecursivly(cgd, cg.ClientGroup_Resources);
+        FillSubGroupsAndClientsRecursivly(cgd, cg.ClientGroup_Resources_Children);
       }
 
       //get the clients
-      var qClients = (from cl in Context.Clients
-               where cl.Resource.ClientGroup_Resources.Any(cgr => cgr.ClientGroupId.Equals(parentClientGroup.Id))
+      var qClients = (from cl in Context.Resources.OfType<Client>()
+               where cl.ClientGroup_Resources_Parents.Any(cgr => cgr.ClientGroupId.Equals(parentClientGroup.Id))
                select cl);
       foreach (Client client in qClients) {
@@ -114,13 +114,14 @@
     public IEnumerable<Guid> FindAllGroupAndParentGroupIdsForClient(Guid clientId) {
       List<Guid> guids = new List<Guid>();
-      Client c = Context.Clients.SingleOrDefault(client => client.ResourceId.Equals(clientId));
-      FindAllGroupAndParentGroupIdsForClientRecursive(c.Resource, guids);
+      Client c = Context.Resources.OfType<Client>().SingleOrDefault(client => client.ResourceId.Equals(clientId));
+      FindAllGroupAndParentGroupIdsForClientRecursive(c, guids);
       return guids;
     }
 
+    //Massivly error Prone
     private void FindAllGroupAndParentGroupIdsForClientRecursive(Resource resource, List<Guid> guids) {
-      foreach (ClientGroup_Resource cgr in resource.ClientGroup_Resources) {
+      foreach (ClientGroup_Resource cgr in resource.ClientGroup_Resources_Parents) {
         guids.Add(cgr.ClientGroupId);
-        FindAllGroupAndParentGroupIdsForClientRecursive(cgr.ClientGroup.Resource, guids);        
+        FindAllGroupAndParentGroupIdsForClientRecursive(cgr.ClientGroup, guids);        
       }
     }
@@ -133,9 +134,7 @@
       if (target == null)
         target = new ClientGroup();
-      if (target.Resource == null)
-        target.Resource = new Resource();
 
-      target.Resource.Name = source.Name;
-      target.Resource.ResourceId = source.Id;
+      target.Name = source.Name;
+      target.ResourceId = source.Id;
 
       return target;
@@ -149,5 +148,5 @@
 
       target.Id = source.ResourceId;
-      target.Name = source.Resource.Name;
+      target.Name = source.Name;
 
       return target;
@@ -155,6 +154,6 @@
 
     public IEnumerable<ClientGroupDto> FindByName(string res) {
-      return (from cq in Context.ClientGroups
-              where cq.Resource.Name == res
+      return (from cq in Context.Resources.OfType<ClientGroup>()
+              where cq.Name == res
               select EntityToDto(cq, null)).ToList();      
     }
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/ContextFactory.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/ContextFactory.cs	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/ContextFactory.cs	(revision 3931)
@@ -5,4 +5,5 @@
 using System.Data.Common;
 using System.Data.SqlClient;
+using HeuristicLab.Tracing;
 
 namespace HeuristicLab.Hive.Server.LINQDataAccess {
@@ -16,6 +17,9 @@
     public static HiveDataContext Context { 
       get {
-        if(_hiveDataContext == null) 
-          _hiveDataContext = new HiveDataContext();
+        if (_hiveDataContext == null) {
+          Logger.Debug("Requested new Data Context");
+          _hiveDataContext = new HiveDataContext("Data Source=127.0.0.1;Initial Catalog=HeuristicLab.Hive.Linq.Test;Integrated Security=SSPI");
+          _hiveDataContext.CommandTimeout = 240;
+        }
         return _hiveDataContext;        
       } 
@@ -32,4 +36,8 @@
       } 
     }
+
+    public static bool IsContextNull() {
+      return _hiveDataContext == null;
+    }
   }
 }
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/HeuristicLab.Hive.Server.LINQDataAccess-3.2.csproj
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/HeuristicLab.Hive.Server.LINQDataAccess-3.2.csproj	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/HeuristicLab.Hive.Server.LINQDataAccess-3.2.csproj	(revision 3931)
@@ -91,9 +91,5 @@
     <Compile Include="ClientGroupDao.cs" />
     <Compile Include="ContextFactory.cs" />
-    <Compile Include="Hive.designer.cs">
-      <AutoGen>True</AutoGen>
-      <DesignTime>True</DesignTime>
-      <DependentUpon>Hive.dbml</DependentUpon>
-    </Compile>
+    <Compile Include="HiveDataContext.cs" />
     <Compile Include="JobDao.cs" />
     <Compile Include="LINQDataAccessPlugin.cs" />
@@ -109,9 +105,4 @@
   </ItemGroup>
   <ItemGroup>
-    <None Include="Hive.dbml">
-      <Generator>MSLinqToSQLGenerator</Generator>
-      <LastGenOutput>Hive.designer.cs</LastGenOutput>
-      <SubType>Designer</SubType>
-    </None>
     <None Include="HeuristicLab.snk" />
     <None Include="Properties\AssemblyInfo.frame" />
@@ -144,11 +135,11 @@
   <ItemGroup>
     <None Include="app.config" />
-    <None Include="Hive.dbml.layout">
-      <DependentUpon>Hive.dbml</DependentUpon>
-    </None>
     <None Include="Properties\Settings.settings">
       <Generator>SettingsSingleFileGenerator</Generator>
       <LastGenOutput>Settings.Designer.cs</LastGenOutput>
     </None>
+  </ItemGroup>
+  <ItemGroup>
+    <Content Include="HiveDataContext.xml" />
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/Hive.dbml
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/Hive.dbml	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/Hive.dbml	(revision 3931)
@@ -78,5 +78,4 @@
       <Association Name="Resource_UptimeCalendar" Member="UptimeCalendars" ThisKey="ResourceId" OtherKey="ResourceId" Type="UptimeCalendar" />
       <Association Name="Resource_Client" Member="Client" ThisKey="ResourceId" OtherKey="ResourceId" Type="Client" Cardinality="One" />
-      <Association Name="Resource_Client1" Member="Client1" ThisKey="ResourceId" OtherKey="ResourceId" Type="Client" Cardinality="One" />
     </Type>
   </Table>
@@ -133,5 +132,4 @@
       <Association Name="Client_Job" Member="Jobs" ThisKey="ResourceId" OtherKey="ResourceId" Type="Job" />
       <Association Name="Resource_Client" Member="Resource" ThisKey="ResourceId" OtherKey="ResourceId" Type="Resource" IsForeignKey="true" DeleteRule="CASCADE" DeleteOnNull="true" />
-      <Association Name="Resource_Client1" Member="Resource1" ThisKey="ResourceId" OtherKey="ResourceId" Type="Resource" IsForeignKey="true" />
       <Association Name="ClientConfig_Client" Member="ClientConfig" ThisKey="ClientConfigId" OtherKey="ClientConfigId" Type="ClientConfig" IsForeignKey="true" DeleteRule="SET NULL" />
     </Type>
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/Hive.dbml.layout
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/Hive.dbml.layout	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/Hive.dbml.layout	(revision 3931)
@@ -166,11 +166,4 @@
       </nodes>
     </associationConnector>
-    <associationConnector edgePoints="[(5.0625 : 6.94399251302083); (5.0625 : 8.25)]" fixedFrom="NotFixed" fixedTo="NotFixed">
-      <AssociationMoniker Name="/HiveDataContext/Resource/Resource_Client1" />
-      <nodes>
-        <classShapeMoniker Id="e44e8355-4290-42f0-8b46-4473e91e504b" />
-        <classShapeMoniker Id="51cb317e-413a-4e25-a9b6-e903322f0371" />
-      </nodes>
-    </associationConnector>
     <associationConnector edgePoints="[(4.75 : 12); (4.75 : 11.1747054036458)]" fixedFrom="NotFixed" fixedTo="NotFixed">
       <AssociationMoniker Name="/HiveDataContext/ClientConfig/ClientConfig_Client" />
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/Hive.designer.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/Hive.designer.cs	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/Hive.designer.cs	(revision 3931)
@@ -1512,6 +1512,4 @@
 		private EntityRef<Client> _Client;
 		
-		private EntityRef<Client> _Client1;
-		
     #region Extensibility Method Definitions
     partial void OnLoaded();
@@ -1531,5 +1529,4 @@
 			this._UptimeCalendars = new EntitySet<UptimeCalendar>(new Action<UptimeCalendar>(this.attach_UptimeCalendars), new Action<UptimeCalendar>(this.detach_UptimeCalendars));
 			this._Client = default(EntityRef<Client>);
-			this._Client1 = default(EntityRef<Client>);
 			OnCreated();
 		}
@@ -1668,33 +1665,4 @@
 					}
 					this.SendPropertyChanged("Client");
-				}
-			}
-		}
-		
-		[Association(Name="Resource_Client1", Storage="_Client1", ThisKey="ResourceId", OtherKey="ResourceId", IsUnique=true, IsForeignKey=false)]
-		public Client Client1
-		{
-			get
-			{
-				return this._Client1.Entity;
-			}
-			set
-			{
-				Client previousValue = this._Client1.Entity;
-				if (((previousValue != value) 
-							|| (this._Client1.HasLoadedOrAssignedValue == false)))
-				{
-					this.SendPropertyChanging();
-					if ((previousValue != null))
-					{
-						this._Client1.Entity = null;
-						previousValue.Resource1 = null;
-					}
-					this._Client1.Entity = value;
-					if ((value != null))
-					{
-						value.Resource1 = this;
-					}
-					this.SendPropertyChanged("Client1");
 				}
 			}
@@ -2620,6 +2588,4 @@
 		private EntityRef<Resource> _Resource;
 		
-		private EntityRef<Resource> _Resource1;
-		
 		private EntityRef<ClientConfig> _ClientConfig;
 		
@@ -2657,5 +2623,4 @@
 			this._Jobs = new EntitySet<Job>(new Action<Job>(this.attach_Jobs), new Action<Job>(this.detach_Jobs));
 			this._Resource = default(EntityRef<Resource>);
-			this._Resource1 = default(EntityRef<Resource>);
 			this._ClientConfig = default(EntityRef<ClientConfig>);
 			OnCreated();
@@ -2950,38 +2915,4 @@
 		}
 		
-		[Association(Name="Resource_Client1", Storage="_Resource1", ThisKey="ResourceId", OtherKey="ResourceId", IsForeignKey=true)]
-		public Resource Resource1
-		{
-			get
-			{
-				return this._Resource1.Entity;
-			}
-			set
-			{
-				Resource previousValue = this._Resource1.Entity;
-				if (((previousValue != value) 
-							|| (this._Resource1.HasLoadedOrAssignedValue == false)))
-				{
-					this.SendPropertyChanging();
-					if ((previousValue != null))
-					{
-						this._Resource1.Entity = null;
-						previousValue.Client1 = null;
-					}
-					this._Resource1.Entity = value;
-					if ((value != null))
-					{
-						value.Client1 = this;
-						this._ResourceId = value.ResourceId;
-					}
-					else
-					{
-						this._ResourceId = default(System.Guid);
-					}
-					this.SendPropertyChanged("Resource1");
-				}
-			}
-		}
-		
 		[Association(Name="ClientConfig_Client", Storage="_ClientConfig", ThisKey="ClientConfigId", OtherKey="ClientConfigId", IsForeignKey=true, DeleteRule="SET NULL")]
 		public ClientConfig ClientConfig
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/JobDao.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/JobDao.cs	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/JobDao.cs	(revision 3931)
@@ -63,4 +63,12 @@
     }
 
+    public void SetBinaryJobFile(Guid jobId, byte[] data) {
+      Job j = (from job in Context.Jobs
+               where job.JobId.Equals(jobId)
+               select job).SingleOrDefault();
+      j.SerializedJob = data;
+      CommitChanges();
+    }
+
     public SerializedJob InsertWithAttachedJob(SerializedJob job) {
       Job j = DtoToEntity(job.JobInfo, null);
@@ -121,5 +129,5 @@
 
     public void AssignClientToJob(Guid clientId, Guid jobId) {
-      Client c = Context.Clients.SingleOrDefault(client => client.ResourceId.Equals(clientId));
+      Client c = Context.Resources.OfType<Client>().SingleOrDefault(client => client.ResourceId.Equals(clientId));
       Job j = Context.Jobs.SingleOrDefault(job => job.JobId.Equals(jobId));
       c.Jobs.Add(j);
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/Properties/Settings.Designer.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/Properties/Settings.Designer.cs	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/Properties/Settings.Designer.cs	(revision 3931)
@@ -28,5 +28,5 @@
         [global::System.Configuration.SpecialSettingAttribute(global::System.Configuration.SpecialSetting.ConnectionString)]
         [global::System.Configuration.DefaultSettingValueAttribute("Data Source=127.0.0.1;Initial Catalog=HeuristicLab.Hive.Linq;Integrated Security=" +
-            "True")]
+            "True;MultipleActiveResultSets=True")]
         public string HeuristicLab_Hive_LinqConnectionString {
             get {
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/Properties/Settings.settings
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/Properties/Settings.settings	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/Properties/Settings.settings	(revision 3931)
@@ -6,8 +6,8 @@
       <DesignTimeValue Profile="(Default)">&lt;?xml version="1.0" encoding="utf-16"?&gt;
 &lt;SerializableConnectionString xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema"&gt;
-  &lt;ConnectionString&gt;Data Source=127.0.0.1;Initial Catalog=HeuristicLab.Hive.Linq;Integrated Security=True&lt;/ConnectionString&gt;
+  &lt;ConnectionString&gt;Data Source=127.0.0.1;Initial Catalog=HeuristicLab.Hive.Linq;Integrated Security=True;MultipleActiveResultSets=True&lt;/ConnectionString&gt;
   &lt;ProviderName&gt;System.Data.SqlClient&lt;/ProviderName&gt;
 &lt;/SerializableConnectionString&gt;</DesignTimeValue>
-      <Value Profile="(Default)">Data Source=127.0.0.1;Initial Catalog=HeuristicLab.Hive.Linq;Integrated Security=True</Value>
+      <Value Profile="(Default)">Data Source=127.0.0.1;Initial Catalog=HeuristicLab.Hive.Linq;Integrated Security=True;MultipleActiveResultSets=True</Value>
     </Setting>
   </Settings>
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/UptimeCalendarDao.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/UptimeCalendarDao.cs	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/UptimeCalendarDao.cs	(revision 3931)
@@ -99,20 +99,20 @@
 
     public IEnumerable<AppointmentDto> GetCalendarForClient(ClientDto client) {
-      Client dbc = Context.Clients.SingleOrDefault(c => c.ResourceId.Equals(client.Id));
+      Client dbc = Context.Resources.OfType<Client>().SingleOrDefault(c => c.ResourceId.Equals(client.Id));
       IList<AppointmentDto> appointments = new List<AppointmentDto>();
       if (dbc != null) {
         ClientGroup cg =
-          Context.ClientGroups.SingleOrDefault(cgroup => cgroup.ResourceId.Equals(dbc.UseCalendarFromResourceId));
+          Context.Resources.OfType<ClientGroup>().SingleOrDefault(cgroup => cgroup.ResourceId.Equals(dbc.UseCalendarFromResourceId));
         //in case no plan has been set
         if (cg == null)
-          if (dbc.Resource.ClientGroup_Resources.FirstOrDefault() != null)
-            cg = dbc.Resource.ClientGroup_Resources.FirstOrDefault().ClientGroup;
+          if (dbc.ClientGroup_Resources_Parents.FirstOrDefault() != null)
+            cg = dbc.ClientGroup_Resources_Parents.FirstOrDefault().ClientGroup;
 
         if (cg == null)
           return appointments;
 
-        while (cg.Resource.UptimeCalendars.Count == 0) {
-          if (cg.Resource.ClientGroup_Resources.FirstOrDefault() != null)
-            cg = cg.Resource.ClientGroup_Resources.FirstOrDefault().ClientGroup;
+        while (cg.UptimeCalendars.Count == 0) {
+          if (cg.ClientGroup_Resources_Parents.FirstOrDefault() != null)
+            cg = cg.ClientGroup_Resources_Parents.FirstOrDefault().ClientGroup;
           else {
             break;
@@ -120,5 +120,5 @@
         }
 
-        foreach (UptimeCalendar appointment in cg.Resource.UptimeCalendars) {
+        foreach (UptimeCalendar appointment in cg.UptimeCalendars) {
           appointments.Add(EntityToDto(appointment,null));  
         }
@@ -131,10 +131,10 @@
       
       //Get the current ClientGroup
-      ClientGroup cg = Context.ClientGroups.SingleOrDefault(cgroup => cgroup.ResourceId.Equals(groupId));
+      ClientGroup cg = Context.Resources.OfType<ClientGroup>().SingleOrDefault(cgroup => cgroup.ResourceId.Equals(groupId));
       if(cg == null)
         return;
 
       //Get all the affected clients
-      List<Client> clients = Context.Clients.Where(c => c.UseCalendarFromResourceId.Equals(cg.ResourceId)).ToList();
+      List<Client> clients = Context.Resources.OfType<Client>().Where(c => c.UseCalendarFromResourceId.Equals(cg.ResourceId)).ToList();
       
       //Set new state
@@ -146,6 +146,6 @@
 
       //Get all Subgroups
-      List<ClientGroup> groups = (from cg1 in Context.ClientGroups
-                                  where cg1.Resource.ClientGroup_Resources.Any(
+      List<ClientGroup> groups = (from cg1 in Context.Resources.OfType<ClientGroup>()
+                                  where cg1.ClientGroup_Resources_Parents.Any(
                                 cgr => cgr.ClientGroupId.Equals(groupId))
                               select cg1).ToList();
@@ -154,6 +154,6 @@
       //otherweise - propagate
       foreach (ClientGroup cgroup in groups) {
-        if(cgroup.Resource.UptimeCalendars.Count == 0)
-          NotifyClientsOfNewCalendar(groupId, forcePush);        
+        if(cgroup.UptimeCalendars.Count == 0)
+          NotifyClientsOfNewCalendar(cgroup.ResourceId, forcePush);        
       }
     }
Index: /branches/3.2/sources/HeuristicLab.Hive.Server/3.2/ServiceCallInterception.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server/3.2/ServiceCallInterception.cs	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server/3.2/ServiceCallInterception.cs	(revision 3931)
@@ -16,7 +16,8 @@
 
     public object Invoke(IMethodInvocation invocation) {
+      DateTime start = DateTime.Now;
       Logger.Info("Entering Method: " + invocation.Method.Name);
 
-      if(ContextFactory.Context != null) {
+      if(!ContextFactory.IsContextNull()) {
         Logger.Info("Not null context found - why wasn't this disposed?");
         try {
@@ -28,8 +29,9 @@
         ContextFactory.Context = null;
       }
-
+      Logger.Info("Context info: Timeout: " + ContextFactory.Context.Connection.ConnectionTimeout + " | " +
+                  ContextFactory.Context.Connection.State + " | Conn: " + ContextFactory.Context + " | HashCode is: " + ContextFactory.Context.Connection.GetHashCode());
       Object obj = null;
 
-      if (invocation.Method.Name.Equals("SendStreamedJob") || invocation.Method.Name.Equals("StoreFinishedJobResultStreamed")) {        
+      /*if (invocation.Method.Name.Equals("SendStreamedJob") || invocation.Method.Name.Equals("StoreFinishedJobResultStreamed")) {        
         ContextFactory.Context.Connection.Open();
         if(UseTransactions) {
@@ -48,5 +50,5 @@
           ContextFactory.Context = null;
         }        
-      } else {
+      } else { */
         if(UseTransactions) {
           using (TransactionScope scope = new TransactionScope(TransactionScopeOption.Required, new TransactionOptions { IsolationLevel = ApplicationConstants.ISOLATION_LEVEL_SCOPE })) {
@@ -57,5 +59,6 @@
             }
             catch (Exception e) {
-              Logger.Error("Exception occured during method invocation", e);              
+              Logger.Error("Exception occured during method invocation", e);     
+              Logger.Error("Inner Exception: ", e.InnerException);
             }
             finally {
@@ -80,7 +83,15 @@
           }  
         }
+      //}       
+      TimeSpan ts = DateTime.Now - start;
+      if (ts.Seconds > 2) {
+        Logger.Warn("Invocation took: " + ts);
+      } else if (ts.Seconds > 10) {
+        Logger.Error("Invocation took: " + ts);
+      } else {
+        Logger.Info("Invocation took: " + ts); ;
       }
       Logger.Info("Leaving Method: " + invocation.Method.Name);
-
+      
       return obj;
     }
